# coding: utf-8

"""
    Corellium API

    REST API to manage your virtual devices.  # noqa: E501

    The version of the OpenAPI document: 7.3.0
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from corellium_api.configuration import Configuration


class DomainAuthProviderRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'provider_type': 'str',
        'enabled': 'bool',
        'label': 'str',
        'config': 'OpenIDConfig'
    }

    attribute_map = {
        'provider_type': 'providerType',
        'enabled': 'enabled',
        'label': 'label',
        'config': 'config'
    }

    def __init__(self, provider_type=None, enabled=None, label=None, config=None, local_vars_configuration=None):  # noqa: E501
        """DomainAuthProviderRequest - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._provider_type = None
        self._enabled = None
        self._label = None
        self._config = None
        self.discriminator = None

        self.provider_type = provider_type
        self.enabled = enabled
        self.label = label
        if config is not None:
            self.config = config

    @property
    def provider_type(self):
        """Gets the provider_type of this DomainAuthProviderRequest.  # noqa: E501

        Provider Type  # noqa: E501

        :return: The provider_type of this DomainAuthProviderRequest.  # noqa: E501
        :rtype: str
        """
        return self._provider_type

    @provider_type.setter
    def provider_type(self, provider_type):
        """Sets the provider_type of this DomainAuthProviderRequest.

        Provider Type  # noqa: E501

        :param provider_type: The provider_type of this DomainAuthProviderRequest.  # noqa: E501
        :type provider_type: str
        """
        if self.local_vars_configuration.client_side_validation and provider_type is None:  # noqa: E501
            raise ValueError("Invalid value for `provider_type`, must not be `None`")  # noqa: E501

        self._provider_type = provider_type

    @property
    def enabled(self):
        """Gets the enabled of this DomainAuthProviderRequest.  # noqa: E501

        Enabled/Disabled  # noqa: E501

        :return: The enabled of this DomainAuthProviderRequest.  # noqa: E501
        :rtype: bool
        """
        return self._enabled

    @enabled.setter
    def enabled(self, enabled):
        """Sets the enabled of this DomainAuthProviderRequest.

        Enabled/Disabled  # noqa: E501

        :param enabled: The enabled of this DomainAuthProviderRequest.  # noqa: E501
        :type enabled: bool
        """
        if self.local_vars_configuration.client_side_validation and enabled is None:  # noqa: E501
            raise ValueError("Invalid value for `enabled`, must not be `None`")  # noqa: E501

        self._enabled = enabled

    @property
    def label(self):
        """Gets the label of this DomainAuthProviderRequest.  # noqa: E501

        Login Button Text  # noqa: E501

        :return: The label of this DomainAuthProviderRequest.  # noqa: E501
        :rtype: str
        """
        return self._label

    @label.setter
    def label(self, label):
        """Sets the label of this DomainAuthProviderRequest.

        Login Button Text  # noqa: E501

        :param label: The label of this DomainAuthProviderRequest.  # noqa: E501
        :type label: str
        """

        self._label = label

    @property
    def config(self):
        """Gets the config of this DomainAuthProviderRequest.  # noqa: E501


        :return: The config of this DomainAuthProviderRequest.  # noqa: E501
        :rtype: OpenIDConfig
        """
        return self._config

    @config.setter
    def config(self, config):
        """Sets the config of this DomainAuthProviderRequest.


        :param config: The config of this DomainAuthProviderRequest.  # noqa: E501
        :type config: OpenIDConfig
        """

        self._config = config

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DomainAuthProviderRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, DomainAuthProviderRequest):
            return True

        return self.to_dict() != other.to_dict()
