# coding: utf-8

"""
    Corellium API

    REST API to manage your virtual devices.  # noqa: E501

    The version of the OpenAPI document: 7.3.0
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from corellium_api.configuration import Configuration


class TouchInput(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'position': 'object',
        'buttons': 'list[TouchInputButtonsInner]',
        'normalized': 'bool',
        'wait': 'float'
    }

    attribute_map = {
        'position': 'position',
        'buttons': 'buttons',
        'normalized': 'normalized',
        'wait': 'wait'
    }

    def __init__(self, position=None, buttons=None, normalized=None, wait=None, local_vars_configuration=None):  # noqa: E501
        """TouchInput - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._position = None
        self._buttons = None
        self._normalized = None
        self._wait = None
        self.discriminator = None

        self.position = position
        self.buttons = buttons
        self.normalized = normalized
        self.wait = wait

    @property
    def position(self):
        """Gets the position of this TouchInput.  # noqa: E501

        Finger Positions  # noqa: E501

        :return: The position of this TouchInput.  # noqa: E501
        :rtype: object
        """
        return self._position

    @position.setter
    def position(self, position):
        """Sets the position of this TouchInput.

        Finger Positions  # noqa: E501

        :param position: The position of this TouchInput.  # noqa: E501
        :type position: object
        """
        if self.local_vars_configuration.client_side_validation and position is None:  # noqa: E501
            raise ValueError("Invalid value for `position`, must not be `None`")  # noqa: E501

        self._position = position

    @property
    def buttons(self):
        """Gets the buttons of this TouchInput.  # noqa: E501

        Buttons to be held when this position is reached. Either a Button enum object or an ASCII character. No change if not defined.  # noqa: E501

        :return: The buttons of this TouchInput.  # noqa: E501
        :rtype: list[TouchInputButtonsInner]
        """
        return self._buttons

    @buttons.setter
    def buttons(self, buttons):
        """Sets the buttons of this TouchInput.

        Buttons to be held when this position is reached. Either a Button enum object or an ASCII character. No change if not defined.  # noqa: E501

        :param buttons: The buttons of this TouchInput.  # noqa: E501
        :type buttons: list[TouchInputButtonsInner]
        """

        self._buttons = buttons

    @property
    def normalized(self):
        """Gets the normalized of this TouchInput.  # noqa: E501

        true if you want to use normalized x,y coordinates from 0-10000 (eg 5000,5000 is always center of screen)  # noqa: E501

        :return: The normalized of this TouchInput.  # noqa: E501
        :rtype: bool
        """
        return self._normalized

    @normalized.setter
    def normalized(self, normalized):
        """Sets the normalized of this TouchInput.

        true if you want to use normalized x,y coordinates from 0-10000 (eg 5000,5000 is always center of screen)  # noqa: E501

        :param normalized: The normalized of this TouchInput.  # noqa: E501
        :type normalized: bool
        """

        self._normalized = normalized

    @property
    def wait(self):
        """Gets the wait of this TouchInput.  # noqa: E501

        Duration to wait before this input is executed.  Instant if not defined.  # noqa: E501

        :return: The wait of this TouchInput.  # noqa: E501
        :rtype: float
        """
        return self._wait

    @wait.setter
    def wait(self, wait):
        """Sets the wait of this TouchInput.

        Duration to wait before this input is executed.  Instant if not defined.  # noqa: E501

        :param wait: The wait of this TouchInput.  # noqa: E501
        :type wait: float
        """

        self._wait = wait

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TouchInput):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, TouchInput):
            return True

        return self.to_dict() != other.to_dict()
